<?

 /*************************************************************************************
 * Filename: modules/tags.php
 *
 * This file is part of the Blog JAS plugin.
 * Copyright 2003-2016 by Matthijs Schuurman
 *
 * The Blog JAS plugin is free software under the terms of the
 * GNU General Public License version 3 or any later version.
 *
 * For information about the license please refer to:
 * LICENSE.txt in the root of the plugin or http://jas.junerules.com/plugins/blog/
 *************************************************************************************/


 require_once($_path["include"]."module.php");

 class Plugin_Module_blog_tags extends Module
 {
  function __construct(&$data)
  {
   parent::__construct($data);

   $this->data->title="Blog tags";

   $this->data->addField("tag", "title", "all", "title", 1, 50, false, "Tag");
   $this->data->addUnique("tag", "tag");

   $this->data->defaultFields();

   $this->data->addReference("blog_tagsmapping", "blog_entries", "nr", "*:*", "nr");

   $this->data->addField("cloud_size", "float", "", "", false, false, false, "Size for cloud", "Ranges from min to max and is round if field type is nr");

   $this->data->sortOrder("tag");
  }

  function viewPostGet()
  {
   if($this->data->check("use", "show", "cloud_size"))
   {
    //gather stats
    $d=clone $this->data->getReferenceData("blog_tagsmapping");
    $d->setAction("view");
    $d->setExtra("all");
    $d->setShowFields("blog_tags", "blog_entries");

    $d->clearValues();
    $d->setValue("aggregation_field", "blog_tags");
    $d->setValue("aggregation_type", "count");

    $d->field["blog_tags"]["type"]="array";
    $d->setOperator("blog_tags", "in");
    $d->setValue("blog_tags", $this->data->field["nr"]["value"]);

    if(!$d->get())
    {
     $this->data->e->add($d->e);
     return false;
    }

    $totals=Array();
    while($d->next())
     $totals[$d->v["blog_tags"]]=$d->v["blog_entries"];

    $max=0;
    for($c=0;$c<$this->data->vmax;$c++)
    {
     if(isset($totals[$this->data->field["nr"]["value"][$c]]))
      $this->data->field["cloud_size"]["value"][$c]=$totals[$this->data->field["nr"]["value"][$c]];
     else
      $this->data->field["cloud_size"]["value"][$c]=0;

     if($this->data->field["cloud_size"]["value"][$c]>$max)
      $max=$this->data->field["cloud_size"]["value"][$c];
    }

    if(!$max) //no used tags
     return true; //done

    for($c=0;$c<$this->data->vmax;$c++)
    {
     $this->data->field["cloud_size"]["value"][$c]/=$max;

     if($this->data->field["cloud_size"]["max"])
      $this->data->field["cloud_size"]["value"][$c]*=($this->data->field["cloud_size"]["max"]-$this->data->field["cloud_size"]["min"]);

     if($this->data->field["cloud_size"]["min"])
      $this->data->field["cloud_size"]["value"][$c]+=$this->data->field["cloud_size"]["min"];

     if($this->data->field["cloud_size"]["type"]=="nr")
      $this->data->field["cloud_size"]["value"][$c]=round($this->data->field["cloud_size"]["value"][$c]);
    }
   }

   return true;
  }
 }
?>
